//----------------------------------------------------------------------------
// The simple version of single Leg kontroller
// oerate with 3 pwm's value and measure 3 servo's position.
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "PSoCGPIOINT.h"
#include "mathematic.h"

struct I2C_Regs {    // Example I2C interface structure  
    BYTE bNognomer; //for debug compability  //0
	
	WORD wPosMaxValA; // 1 2
	WORD wPosMinValA; // 3 4
	WORD wPosDefValA; // 5 6      raznica mezhdu polozhenijem servi 0 i logicheskim 0 mat modeli
	WORD wPWMCoeftA;  // 7 8
	
	
	WORD wPosMaxValB; // 9 10
	WORD wPosMinValB; // 11 12
	WORD wPosDefValB; // 13 14 raznica mezhdu polozhenijem servi 0 i logicheskim 0 mat modeli
	WORD wPWMCoeftB; //  15 16
	
	WORD wPosMaxValG;  // 17 18 
	WORD wPosMinValG;  // 19 20
	WORD wPosDefValG; //  21 22 raznica mezhdu polozhenijem servi 0 i logicheskim 0 mat modeli
	WORD wPWMCoeftG;  //  23 24
	
	int iNposX;   //25 26
	int iNposY;   //27 28
	int iNposZ;   //29 30 
	
	//        0:0      0:0             ||   \                              /|\y
	//   ******O B      |---------> W  ||    \       |------W-----|         |
	//          \       |              ||     0:0    |            |         |   
	//           \      |              ||     |O-----O------O------   ------|------>
	//           O A    |              ||     /G     B      A               |      x
	//           |      |              ||    /                              |
	//           |     \|/ Z           ||   /                               |
	//                  
	
	BYTE bChangesApplyed; //31
	
	WORD wVoltA; //32 33
	WORD wVoltB; // 34 35
	WORD wVoltG; // 36 37
	
} MyI2C_Regs;  

struct slave_addr_I2C_Reg {    // Example I2C interface structure  
	BYTE bSlaveAddr;
} sl_Addr_I2C_Reg;

WORD wWaittimer;
DWORD dTmp;
WORD wPWMCoeftA,wPWMCoeftB,wPWMCoeftG,wShiftA,wShiftB,wShiftG;
WORD wPosMinValA,wPosMinValB,wPosMinValG,wPosMaxValA,wPosMaxValB,wPosMaxValG;
int wx,wy,wz;

void main(void)
{   
    M8C_EnableGInt;
	
	EzI2Cs_SetRamBuffer(sizeof(MyI2C_Regs),sizeof(MyI2C_Regs)-5, (BYTE *) &MyI2C_Regs);  
    EzI2Cs_Start();
	
	MyI2C_Regs.bChangesApplyed=0;
	INSAMP_1_Start(INSAMP_1_HIGHPOWER);
	
	 ADCINC_1_Start(ADCINC_1_HIGHPOWER);   // Apply power to the SC Block  
     ADCINC_1_GetSamples(0);               // Have ADC run continuously 
   
//=============== begin of initialization =================	 
{ 
	MyI2C_Regs.wPosDefValA=340;
	MyI2C_Regs.wPosDefValB=3580;
	MyI2C_Regs.wPosDefValG=3600;
	
	MyI2C_Regs.wPWMCoeftA=13751;
	MyI2C_Regs.wPWMCoeftB=13751;
	MyI2C_Regs.wPWMCoeftG=13751;
	
	wPosMinValA=3853;
	wPosMinValB=3853;
	wPosMinValG=3853;
	
	wPosMaxValA=15360;
	wPosMaxValB=15360;
	wPosMaxValG=15360;
	
	
	MyI2C_Regs.wPosMinValA=3853;
	MyI2C_Regs.wPosMinValB=3853;
	MyI2C_Regs.wPosMinValG=3853;
	
	MyI2C_Regs.wPosMaxValA=15360;
	MyI2C_Regs.wPosMaxValB=15360;
	MyI2C_Regs.wPosMaxValG=15360;
	
	wShiftA=MyI2C_Regs.wPosDefValA;
    wShiftB=MyI2C_Regs.wPosDefValB;
    wShiftG=MyI2C_Regs.wPosDefValG;
    
	
	wPWMCoeftA=14189; // 14 int, 2 float  = 1grad/Pwm /180 ibo arcos v radianah
    wPWMCoeftB=14189;
	wPWMCoeftG=14189;
	
    wx=464;
	wy=0;
	wz=435;
	
	calcG(wx,wy);
    CalcNextStep(wz,wDlinaW);
	
	
		dTmp=wGamma;
		dTmp=dTmp*wPWMCoeftG;
		dTmp=dTmp>>16;
		dTmp=dTmp+wShiftG;
		wGamma=dTmp;
		
		dTmp=wAlpha;
		dTmp=dTmp*wPWMCoeftA;
		dTmp=dTmp>>16;
		//dTmp=dTmp-wShiftA;
		wAlpha=dTmp;
	
		dTmp=wBetha;
		dTmp=dTmp*wPWMCoeftB;
		dTmp=dTmp>>16;
		//dTmp=dTmp+wShiftB;
		wBetha=dTmp;
		
		// izmenenije direkta A
		wAlpha=wPosMaxValA-wAlpha;
		wAlpha=wAlpha-wShiftA;
		
		// izmenenije direkta B
		//wBetha=wPosMaxValB-wBetha;
		wBetha=wBetha+wShiftB;
	
	if ((wGamma<wPosMinValG)||(wGamma>wPosMaxValG))
		{
		wGamma=9000;
		}
	
	if ((wAlpha<wPosMinValA)||(wAlpha>wPosMaxValA))
	 {
	  wAlpha=9000;
	 }
	 
	if ((wBetha<wPosMinValB)||(wBetha>wPosMaxValB))
	 {
	  wBetha=9000;
	 }
	
	//PWM16_1_WritePulseWidth(wAlpha);  
   // PWM16_2_WritePulseWidth(wBetha);  
	//PWM16_3_WritePulseWidth(wGamma);  
	PWM16_1_WritePulseWidth(9000);  
    PWM16_2_WritePulseWidth(9000);  
	PWM16_3_WritePulseWidth(9000);

  }
//=============== end of initialization ===================	

	PWM16_1_Start();
    PWM16_2_Start(); 
    PWM16_3_Start(); 
	
	
	while(1)
	
	{
	 // while (MyI2C_Regs.bCmd==0);
	  //MyI2C_Regs.bCmd=0;
	/* 
	 if ((REQ_Data_ADDR & REQ_MASK) > 0) //check REQ sygnal
	  {
	   ACN_Data_ADDR=ACN_MASK;  // set ACN sygnal
	   while((REQ_Data_ADDR & REQ_MASK) > 0)  //wait until tranzaction
	   {
	    REQ_Data_ADDR=ACN_MASK;
	   }
	   ACN_Data_ADDR=0; // unset ACN sygnal
	  }
	
	 /*
	  //AMX_IN=0x0F; //connect P0.6 P0.7
	  //AMX_IN=0x0A; //connect P0.4 P0.5
	  //AMX_IN=0x05; //connect P0.2 P0.3
	  //AMX_IN=0x00; //connect P0.0 P0.1
	  
	  AMX_IN=0x05; //connect P0.2 P0.3
	  
      while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
      while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
	  while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
      
	  MyI2C_Regs.wVolt1=ADCINC_1_wGetData(); 
	   
	  
	  AMX_IN=0x0F; //connect P0.6 P0.7 
      while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
      while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
	  while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
	  
	  MyI2C_Regs.wVolt2=ADCINC_1_wGetData(); 
	
	  AMX_IN=0x00; //connect P0.0 P0.1
		
	  while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
      while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  
	  while(ADCINC_1_fIsDataAvailable() == 0);   // Loop until value ready  
      ADCINC_1_fClearFlag();                      // Clear ADC flag  	
		
      MyI2C_Regs.wVolt3=ADCINC_1_wGetData();                 // Get ADC result  
	  */
	  
	if (MyI2C_Regs.bChangesApplyed>0) 
	 {
	    LED_DataShadow^=LED_MASK;
		LED_Data_ADDR=LED_DataShadow;
		
		wPWMCoeftA=MyI2C_Regs.wPWMCoeftA;
		wPWMCoeftB=MyI2C_Regs.wPWMCoeftB;
		wPWMCoeftG=MyI2C_Regs.wPWMCoeftG;
		
	    wShiftA=MyI2C_Regs.wPosDefValA;
        wShiftB=MyI2C_Regs.wPosDefValB;
        wShiftG=MyI2C_Regs.wPosDefValG;
		
		wPosMinValA=MyI2C_Regs.wPosMinValA;
	    wPosMinValB=MyI2C_Regs.wPosMinValB;
	    wPosMinValG=MyI2C_Regs.wPosMinValG;
	
	    wPosMaxValA=MyI2C_Regs.wPosMaxValA;
	    wPosMaxValB=MyI2C_Regs.wPosMaxValB;
	    wPosMaxValG=MyI2C_Regs.wPosMaxValG;
		
		wx=MyI2C_Regs.iNposX;
		wy=MyI2C_Regs.iNposY;
		wz=MyI2C_Regs.iNposZ;
	//=====coords recalculation begin=======  
	{
		calcG(wx,wy);
		CalcNextStep(wz,wDlinaW);
		
		dTmp=wGamma;
		dTmp=dTmp*wPWMCoeftG;
		dTmp=dTmp>>16;
	//	dTmp=dTmp+wShiftG;
		wGamma=dTmp;
		
		dTmp=wAlpha;
		dTmp=dTmp*wPWMCoeftA;
		dTmp=dTmp>>16;
		//dTmp=dTmp-wShiftA;
		wAlpha=dTmp;
	
		dTmp=wBetha;
		dTmp=dTmp*wPWMCoeftB;
		dTmp=dTmp>>16;
		//dTmp=dTmp+wShiftB;
		wBetha=dTmp;
		
		// izmenenije direkta A
		wAlpha=wPosMaxValA-wAlpha;
		wAlpha=wAlpha-wShiftA;
		
		// izmenenije direkta B
		//wBetha=wPosMaxValB+wBetha;
		wBetha=wBetha+wShiftB;
		
		wGamma=wGamma+wShiftG;
		
		if ((wGamma<wPosMinValG)||(wGamma>wPosMaxValG))
			{
			 wGamma=9000;
			}
		
		if ((wAlpha<wPosMinValA)||(wAlpha>wPosMaxValA))
		   {
	        wAlpha=9000;
		   }
		
		if ((wBetha<wPosMinValB)||(wBetha>wPosMaxValB))
		  {
		   wBetha=9000;
		  }
	 } 
    //=====coords recalculation end=========
	  
	  if  (MyI2C_Regs.bChangesApplyed==2) //coords
	   {
	  PWM16_1_Stop();
      PWM16_1_WritePulseWidth(wAlpha);  
      PWM16_1_Start();  
	  
	  PWM16_2_Stop();
      PWM16_2_WritePulseWidth(wBetha);
	  PWM16_2_Start();  
	  
	  PWM16_3_Stop();
      PWM16_3_WritePulseWidth(wGamma);  
	  PWM16_3_Start(); 
	   }
	  
	  if (MyI2C_Regs.bChangesApplyed==1)
	    {
		 PWM16_1_Stop();
         PWM16_1_WritePulseWidth(wAlpha);
		 //PWM16_1_WritePulseWidth(wBetha);
         PWM16_1_Start();  
	  
	     PWM16_2_Stop();
        PWM16_2_WritePulseWidth(wBetha);
		// PWM16_2_WritePulseWidth(wAlpha);
	     PWM16_2_Start();  
	  
	     PWM16_3_Stop();
         PWM16_3_WritePulseWidth(wGamma);  
	     PWM16_3_Start(); 
		}
	  if (MyI2C_Regs.bChangesApplyed==3)
	   {
	    
		 PWM16_1_Stop();
         PWM16_1_WritePulseWidth(wShiftA);  
         PWM16_1_Start();  
	  
	     PWM16_2_Stop();
         PWM16_2_WritePulseWidth(wShiftB);
	     PWM16_2_Start();  
	  
	     PWM16_3_Stop();
         PWM16_3_WritePulseWidth(wShiftG);  
	     PWM16_3_Start(); 
	   }
	  
//	    if (MyI2C_Regs.bChangesApplyed==2)
//	   {
//	    PWM16_1_Start();
//		PWM16_2_Start();
//		PWM16_3_Start();
//	   }
	  
	  MyI2C_Regs.bChangesApplyed = 0;
	  
	  }
	  
	//TX8_1_PutCRLF();
	//TX8_1_Write((BYTE*)&(MyI2C_Regs.wVolts),2);
	//TX8_1_PutChar(0xff);
	//TX8_1_PutChar(0xff);  
	  
	}
	
}
