#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "PSoCGPIOINT.h"
#include <stdlib.h>

extern const WORD awDistTable[]; 
extern const WORD awAcosTable[]; 


int icalcdist(int x, int y)
{

// funkcija vicheslenija distancii
// vhodnije i vihodnije dannije v formate 1:10:5
// diapazon rasstojanijj ot 0 do 28.1 (dlina raspramlennoj nogi)

//kak rabotajet:
//
//          Y|
//           |-----* point
//           |    /|
//           |  d/ |
//           |  /  |
//           | /   |
//           |/    |
//           --------- X
//         o
//
//We know X and Y, therefore, we can work out the angle the hyptonuse makes
//with the plane, and therefore, work out the value of d.
//
//What this actually equates to is:
//
//             d = X / ( cos (arctan(y/x) )
//
//will also give the correct answer.  "Screams of dread!" you might say,
//"Thats much harder than the 'ol square root equation."
//
//Not really.
//
//If you precalculate a table of 1/ cos (arctan( theta ) )
//for all of theta (where theta = y/x), then the equation becomes
//
//             d = X * TABLE (Y/X)

int iTmp;
long lTmp;

x=abs(x);
y=abs(y);

if (x==0)
 {
  return y;
 }
if (y==0)
 {
 return x;
 }

if(x>y)
 {
 iTmp=x;
 x=y;
 y=iTmp;
 }
lTmp=y;
 lTmp=lTmp<<6;
// iTmp=x+1;
 lTmp=lTmp/x;
 iTmp=lTmp;
 //iTmp=iTmp>>1;
//iTmp--;
 if (iTmp>1800)
  {
   return y;
  }
 lTmp = awDistTable[iTmp];
 lTmp = lTmp*x;
 lTmp=lTmp>>11; 
 return lTmp;
}


// output format 1 bit sign 1 bit integer part 14 bits fractional part
// inut format 1 sign, 5 integer part 10 bits fractional part
WORD acos_tab (int x)
{
WORD wTmp;
wTmp=0;
if (x>=0)
 {
 if (x<1025)
  {
   wTmp=awAcosTable[x];
   return wTmp;
  }
 }
else
 {
  x=abs(x);
  if (x<1025)
  {
	wTmp=awAcosTable[x];
	wTmp=51472-wTmp;
	return wTmp;
  }
 }
return wTmp;
}

WORD wAlpha;
WORD wBetha;
WORD wGamma;
WORD wDlinaW; // pereshtanaja dlina;

void CalcNextStep(int a, int b) //a -Z , b - W

{
long lTmp,lTmp2;
long lb2,la2;
WORD c,wacos1,wacos2;
int iTmp;


c=icalcdist(a,b);

//

lTmp=a;
lTmp=lTmp<<10;
lTmp=lTmp/c;
iTmp=lTmp;
wacos1=acos_tab(iTmp);

//#define SEGMENT_N (float) 9.0 in format 1:21:10 = 9216    n^2 = 82944
//#define SEGMENT_M (float) 13.6 in format 1:21:10 = 13926    m^2= 189399
// m+N =723; in format 1:10:5
// 2*M*N = 7834;  in format 1:10:5
// m^2-n^2 = 106455;
// m^2+n^2 = 272343;

//angleBetha:= (180/pi)*( arccos(a/c) + arccos(( (a*a)+(b*b)-((m*m)-(n*n) )/((2*n)*c) ));

lTmp=a;
lTmp=lTmp*a;
la2=lTmp; //formt 1:21:10

lTmp=b;
lTmp=lTmp*b;
lb2=lTmp; //formt 1:21:10


lTmp=la2+lb2;
lTmp=lTmp<<5;
lTmp=lTmp-(long)3406561; //formt 1:16:15


lTmp2=(long)576;
lTmp2=lTmp2*c; //formt 1:21:10
lTmp2=lTmp2>>5; //formt 1:26:5

lTmp=lTmp/lTmp2; //must be 10

iTmp=lTmp;

wacos2=acos_tab(iTmp);

if (b>0)
 {
  wBetha=wacos2+wacos1;
 }
else
 {
 wBetha=wacos2-wacos1;
 }
//angleBetha:= (180/pi)*( (-1)*arccos(a/c) + arccos(((n*n)-(m*m)+((a*a)+(b*b)))/((2*n)*c) ));

//angleAlpha:= (180/pi)*( arccos ( ((n*n)+(m*m)-((a*a)+(b*b)))/((2*n)*m) ) )
lTmp=la2+lb2;
lTmp=(long)272343-lTmp;
lTmp=lTmp<<5;
lTmp=lTmp/7834;
iTmp=lTmp;
wAlpha=acos_tab(iTmp);

//angleAlpha:= (180/pi)*( arccos ( ((n*n)+(m*m)-((a*a)+(b*b)))/((2*n)*m) ) )
}


#define PiD2 (WORD)25736 // (Pi/2)/(1/2^14)
void calcG(int x, int y)
{

int k,iTmp1; 
long lTmp1;

k=icalcdist(x,y);
if (k==0)
 {
  wDlinaW=k-176;
  wGamma=25736;
  return;
 }


if ((y==0)&&(x>0)) 
 {
  wDlinaW=k-176;
  wGamma=25736;
  return;
 }
 
if ((x>0)&&(y>0)) //1 chetvertj
 {
   wDlinaW=k-176; //(176 = 5,5)
   lTmp1=y;
   lTmp1=lTmp1<<10;
   lTmp1=lTmp1/k;
   iTmp1=lTmp1;
   wGamma=acos_tab(iTmp1); //ugol kak dla3
   
   return;
 }

if ((x>0)&&(y<0)) //4 chetvertj
 {
 y=abs(y);
 wDlinaW=k-176;
 lTmp1=y;
   lTmp1=lTmp1<<10;
 lTmp1=lTmp1/k;
 iTmp1=lTmp1;
 wGamma=51472-acos_tab(iTmp1);
 return;
 }
 

if ((x<0)&&(y>0))//2 chetvertj
 {
 x=abs(x);
 wDlinaW=0xFFFF-k-175;
 lTmp1=y;
   lTmp1=lTmp1<<10;
 lTmp1=lTmp1/k;
 iTmp1=lTmp1;
 wGamma=51472-acos_tab(iTmp1); //ugol kak dla 4
 return;
 }
 
if ((x<0)&&(y<0)) //3 chetvertj
 {
 x=abs(x);
 y=abs(y);
 wDlinaW=0xFFFF-k-175;;
 lTmp1=y;
   lTmp1=lTmp1<<10;
 lTmp1=lTmp1/k;
 iTmp1=lTmp1;
 wGamma=acos_tab(iTmp1);
 return;
 }

if ((y==0)&&(x<0)) 
 {
  wDlinaW=0xFFFF-k-176;
  wGamma=25736;
  return;
 }

 if ((x==0)&&(y>0))
 {
 wDlinaW=k-176; //(176 = 5,5)
 wGamma=0;
 return;
 }

if ((x==0)&&(y<0))
 {
 wDlinaW=k-176; //(176 = 5,5)
 wGamma=51472;
 return;
 }
 
 
}